%global namedreltag .GA-redhat-1
%global namedversion %{version}%{?namedreltag}

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%define base_name jboss-remoting

%define maven_version 3.2.8.GA-redhat-1

Name:             jboss-remoting3
Version:          3.2.8
Release:          1.GA_redhat_1%{?dist}
Summary:          JBoss Remoting 3
Group:            Development/Libraries

%if %with mead
Source100: org.jboss.remoting3-jboss-remoting-3.2.8.GA-redhat-1-sources.zip
Source101: org.jboss.remoting3-jboss-remoting-3.2.8.GA-redhat-1-patches.zip
Source102: jboss-remoting-3.2.8.GA-redhat-1.jar
Source103: jboss-remoting-3.2.8.GA-redhat-1.pom
Source104: jboss-remoting-3.2.8.GA-redhat-1-javadoc.jar
Source105: jboss-remoting-3.2.8.GA-redhat-1-sources.jar
%endif

License:          LGPLv2+
URL:              http://www.jboss.org/jbossremoting

%if %without mead
# git clone git://github.com/jboss-remoting/jboss-remoting.git
# cd jboss-remoting && git checkout 3.2.8.GA && git checkout-index -f -a --prefix=jboss-remoting-3.2.8.GA/
# rm jboss-remoting-3.2.8.GA/src/test/resources/test-content.bin
# HEAD is now at 7caa69e... Prep 3.2.8.GA
# tar -cJf jboss-remoting-3.2.8.GA-CLEAN.tar.xz jboss-remoting-3.2.8.GA
Source0:          %{base_name}-%{namedversion}-CLEAN.tar.xz
%endif

BuildArch:        noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildRequires:    jpackage-utils
%if %without mead
BuildRequires:    java-devel
BuildRequires:    maven
BuildRequires:    maven-compiler-plugin
BuildRequires:    maven-install-plugin
BuildRequires:    maven-jar-plugin
BuildRequires:    maven-javadoc-plugin
BuildRequires:    maven-release-plugin
BuildRequires:    maven-resources-plugin
BuildRequires:    maven-injection-plugin
BuildRequires:    jboss-parent
BuildRequires:    xnio >= 3.0.0-0.2.CR5
BuildRequires:    jboss-logmanager
BuildRequires:    jboss-logging-tools
BuildRequires:    junit4
BuildRequires:    maven-surefire-provider-junit4
BuildRequires:    apiviz
%endif

Requires:         jpackage-utils
Requires:         java

%description
The purpose of JBoss Remoting is to provide a general purpose framework
for symmetric and asymmetric communication over a network. It supports
various modes of interaction, including invocations, one way messaging,
and asynchronous callbacks.

%if %without mead
%package javadoc
Summary:          Javadocs for %{name}
Group:            Documentation

Requires:         jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.
%endif

%prep
%if %without mead
%setup -q -n %{base_name}-%{namedversion}
%endif

%build
%if %without mead
# Skipped test because of removing binary content from test dir which is required to run them
mvn-rpmbuild -Dmaven.test.skip=true install javadoc:aggregate
%endif

%install
# JAR
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jboss
%if %without mead
cp -p target/%{base_name}-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/jboss/%{base_name}.jar
%else
cp -p %{_sourcedir}/%{base_name}-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/jboss/%{base_name}.jar
%endif

%if %without mead
# APIDOCS
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -rp target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}
%endif

# POM
install -d -m 755 $RPM_BUILD_ROOT%{_mavenpomdir}
%if %without mead
install -pm 644 pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP.jboss-%{base_name}.pom
%else
install -pm 644 %{_sourcedir}/%{base_name}-%{namedversion}.pom $RPM_BUILD_ROOT%{_mavenpomdir}/JPP.jboss-%{base_name}.pom
%endif

# DEPMAP
%add_maven_depmap JPP.jboss-%{base_name}.pom jboss/%{base_name}.jar

%files
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%{_javadir}*/*
#%%doc COPYING.txt

%if %without mead
%files javadoc
%{_javadocdir}/%{name}
%doc COPYING.txt
%endif

%changelog
* Wed May 23 2012 Martha Benitez <mbenitez@redhat.com> - 3.2.8-1.GA_redhat_1
- Upgrade to 3.2.8.GA-redhat-1

* Tue May 08 2012 Martha Benitez <mbenitez@redhat.com> - 3.2.7-1.GA_redhat_1
- Upgrade to 3.2.7.GA-redhat-1

* Mon Mar 26 2012 Martha Benitez <mbenitez@redhat.com> - 3.2.4-1.GA_redhat_1.1
- Upgrade to 3.2.4.GA

* Tue Mar 20 2012 Martha Benitez <mbenitez@redhat.com> - 3.2.2-1.GA_redhat_1.2
- Remove R: jboss-logmanager, jboss-logging-tools, xnio

* Wed Feb 29 2012 Fernando Nasser <fnasser@redhat.com> - 3.2.0-1.GA_redhat_1.1
- Populate java-signed

* Fri Feb 14 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 3.2.2-0.5.GA_redhat_1
- Upgrade to 3.2.2.GA

* Fri Jan 13 2012 Fernando Nasser <fnasser@redhat.com> - 3.2.0-0.4.CR8_redhat_1.1
- Wrap MEAD build for EAP 6

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.0-0.3.CR6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Dec 07 2011 Marek Goldmann <mgoldman@redhat.com> 3.2.0-0.2.CR6
- Upstream release 3.2.0.CR6

* Thu Nov 17 2011 Marek Goldmann <mgoldman@redhat.com> 3.2.0-0.1.CR2
- Upstream release 3.2.0.CR2

* Mon Oct 24 2011 Marek Goldmann <mgoldman@redhat.com> 3.2.0-0.1.Beta3
- Upstream release 3.2.0.Beta3
- Fixed javadocs dir issue

* Fri Aug 05 2011 Marek Goldmann <mgoldman@redhat.com> 3.2.0-0.1.Beta2
- Initial packaging

